#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

//The only argument taken here is a positive integer N, so that a random number betwen -N and N
//can be computed by Master Node.

	int my_rank, world_size, length, value;
        char message[256], name[80];
        MPI_Status status;


        int N = atoi(argv[1]);
	int seed; 
	double rand1 = 0.0;
	double temp = 0.0;
	int my_number = 0;

	seed = time(NULL);
	srand(seed);

	int isend = 0;

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);


	if (my_rank ==0){
		while(isend < world_size-1)
		{
			rand1 = rand();
			temp = rand1 / (double) RAND_MAX;
			my_number = -N + 2*N*temp;
			printf("Master Node: The random number %d between -%d and %d is being sent to node %d\n", my_number, N, N, isend+1);	
			MPI_Send(&my_number, 1, MPI_INT, isend+1, TAG, MPI_COMM_WORLD);
			isend ++;
		}
	}	
	else
	{
		MPI_Recv(&my_number, 1, MPI_INT, 0, TAG, MPI_COMM_WORLD, &status);
		printf("Node %d: The random number %d was received from node %d\n", my_rank, my_number, 0);	
	}

    MPI_Finalize();

}
