#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>

#define TAG 1

int main(int argc, char ** argv) {

    int my_rank, world_size, length, next_rank, prev_rank, value;
    char message[256], name[80];
    MPI_Status status;

    MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

    MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &world_size);

    prev_rank = fmod(my_rank-1, world_size);
    next_rank = fmod(my_rank+1, world_size);

    printf("Goodbye cruel world, this is node %d sending my regards to node %d. \n", my_rank, next_rank);
    MPI_Send(&my_rank, 1, MPI_INT, next_rank, TAG, MPI_COMM_WORLD);
    

    MPI_Recv(&value, 1, MPI_INT, prev_rank, TAG, MPI_COMM_WORLD, &status);
    printf("Don't do it node %d, this is node %d receiving your cry for help! \n", value, my_rank);

    MPI_Finalize();
}
