#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

	int my_rank, world_size, length, value;
	char message[256], name[80];
	MPI_Status status;

        int N = atoi(argv[1]);
	int seed; 
	double rand1 = 0.0;
	double temp = 0.0;
	int my_number = 0;
	int sum_my_numbers = 0;

        MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);

	if (my_rank == 0)
	{
		printf("\nMaster Node: The number you entered was %d \n", N);
		seed = time(NULL);
		srand(seed);
		rand1 = rand();
		temp = rand1 / (double) RAND_MAX;
		my_number = -N + 2*N*temp;
		printf("Master Node: A random number between -%d and %d is %d\n", N, N, my_number);
	}	

	if (my_rank != 0)
	{
		printf("Node %d: My random number between -%d and %d is %d\n", my_rank, N, N, my_number);
	}

	MPI_Bcast(&my_number, 1, MPI_INT, 0, MPI_COMM_WORLD);

	if (my_rank != 0)
	{
		printf("Node %d: My random number between -%d and %d is %d\n", my_rank, N, N, my_number);
		seed = time(NULL);
		srand(seed);
		rand1 = rand();
		temp = rand1 / (double) RAND_MAX;
		my_number = -N + 2*N*temp;
		printf("Node %d: The next random number between -%d and %d is %d\n", my_rank, N, N, my_number);
	}

	MPI_Reduce(&my_number, &sum_my_numbers, 1, MPI_INT, MPI_SUM, 0, MPI_COMM_WORLD);
	if (my_rank == 0)
	{
		printf("Master Node: The sum of these %d random numbers is %d\n", world_size, sum_my_numbers);
	}

        MPI_Finalize();
}
